"""
Django settings for shelfshare project.

Generated by 'django-admin startproject' using Django 4.2.7.

For more information on this file, see
https://docs.djangoproject.com/en/4.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.2/ref/settings/
"""

import os
from pathlib import Path

from dotenv import load_dotenv

load_dotenv()

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

TEMPLATE_DIR = os.path.join(BASE_DIR, "templates")
OUTSIDE_DATA_DIR = BASE_DIR.parent / "data"

LOGS_DIR = OUTSIDE_DATA_DIR / "logs"
LOGS_DIR.mkdir(parents=True, exist_ok=True)

MODELS_DIR = OUTSIDE_DATA_DIR / "models"
MODELS_DIR.mkdir(parents=True, exist_ok=True)

MODELS_DEVELOPMENT_DIR = MODELS_DIR / "development"
MODELS_DEVELOPMENT_DIR.mkdir(parents=True, exist_ok=True)

PROFILERS_DIR = OUTSIDE_DATA_DIR / "profilers"
PROFILERS_DIR.mkdir(parents=True, exist_ok=True)
RANDOM_SEED = 12

TEST_DATASET_DIR = OUTSIDE_DATA_DIR / "test_datasets"

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = "django-insecure-sx30*vsq1+b)lg4%pjcxpqo7308(0kyne$-#_a8z^31zrtpb!w"

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = []


# Application definition

INSTALLED_APPS = [
    "books.apps.BooksConfig",
    "users.apps.UsersConfig",
    "bookexchange.apps.BookexchangeConfig",
    "analytics.apps.AnalyticsConfig",
    "recommend_app.apps.RecommendAppConfig",
    "django.contrib.admin",  # admin site
    "django.contrib.auth",  # auth system
    # frameworks
    "django.contrib.contenttypes",
    "django.contrib.sessions",  # when a user logs in, a session is created that tracks the user’s activity while they’re logged in
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "rest_framework",  # rest framework
]

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
]

ROOT_URLCONF = "shelfshare.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [TEMPLATE_DIR],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ],
        },
    },
]

WSGI_APPLICATION = "shelfshare.wsgi.application"

# Database
# https://docs.djangoproject.com/en/4.2/ref/settings/#databases
DB_SERVER = os.getenv(
    "DB_SERVER", "localhost"
)  # change it to db in the .env file if you want to run the app as part of the docker-compose
DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.postgresql",
        "NAME": "shelfshare",
        "USER": "postgres",
        "PASSWORD": "diplomska",
        "HOST": DB_SERVER,
        "PORT": "5432",
    },
    "development": {
        "ENGINE": "django.db.backends.postgresql",
        "NAME": "development",
        "USER": "postgres",
        "PASSWORD": "diplomska",
        "HOST": DB_SERVER,
        "PORT": "5432",
    },
}


# Password validation
# https://docs.djangoproject.com/en/4.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.2/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "UTC"

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.2/howto/static-files/

STATIC_URL = "static/"
STATICFILES_DIRS = [
    BASE_DIR / "static",
]

# Default primary key field type
# https://docs.djangoproject.com/en/4.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"

REST_FRAMEWORK = {"DEFAULT_PAGINATION_CLASS": "rest_framework.pagination.PageNumberPagination", "PAGE_SIZE": 10}
AUTH_USER_MODEL = "users.User"
# development mode
DEVELOPMENT = os.getenv("DEVELOPMENT", "True")
# logging
if DEVELOPMENT == "True":
    default_log_level = "DEBUG"
    SAVE_MODEL_DIR = MODELS_DEVELOPMENT_DIR
else:  # any other value
    default_log_level = "INFO"
    SAVE_MODEL_DIR = MODELS_DIR
import logging
import sys

LOG_LEVEL = os.getenv("LOG_LEVEL", default_log_level)
LOGGING = {
    "version": 1,
    "disable_existing_loggers": False,
    "formatters": {
        "minimal": {"format": "[%(levelname)s][%(name)s][%(funcName)s]: %(message)s\n"},
        "detailed": {
            "format": "%(levelname)s %(asctime)s [%(name)s:%(filename)s:%(funcName)s:%(lineno)d]\n%(message)s\n"
        },
    },
    "handlers": {
        "console": {
            "class": "logging.StreamHandler",
            "stream": sys.stdout,
            "formatter": "minimal",
            "level": LOG_LEVEL,
        },
        "error": {
            "class": "logging.handlers.RotatingFileHandler",
            "filename": Path(LOGS_DIR, "error.log"),
            "maxBytes": 10485760,  # 1 MB
            "backupCount": 10,
            "formatter": "detailed",
            "level": logging.ERROR,
        },
        "evaluator_file_handler": {
            "class": "logging.handlers.RotatingFileHandler",
            "filename": Path(LOGS_DIR, "evaluator.log"),
            "maxBytes": 10485760,  # 1 MB
            "backupCount": 10,
            "formatter": "minimal",
            "level": logging.INFO,
        },
    },
    "loggers": {
        "root": {
            "handlers": ["console", "error"],
            "level": logging.NOTSET,
        },
        "evaluator": {
            "handlers": ["console", "evaluator_file_handler"],
            "level": logging.NOTSET,
        },
        "django": {
            "handlers": ["console", "error"],
            "level": logging.WARNING,
        },
        "distributed": {
            "handlers": ["console", "error"],
            "level": logging.WARNING,
        },
    },
}
